import path from "path";
import CppProject from "../Project/CppProject";
import { getGlobalProjects, getProjectsByTypeName } from "../Tools/Projects";
import Builder from "./Builder";
import { getBuildDir } from "../Tools/BuildDir";
import fs from "fs"
import printDebug from "../Tools/DebugPrint";
import sourceFilesToString from "../Tools/SourceFilesToString";
import execAsync from "../Tools/ExecAsync";

export default class CppBuilder implements Builder{
    compile = async ()=>{
        const cppProjects  = getProjectsByTypeName("cpp") as CppProject[]
        const tasks = []
        cppProjects.forEach((e)=>{
            printDebug(`making dir ${path.join(getBuildDir(),e.name)}`)
            fs.mkdirSync(path.join(getBuildDir(),e.name),{recursive:true})
            const command  = `${e.compiler.compilerPath} -o ${path.join(getBuildDir(),e.name,`${e.name}.o`)} ${e.optimizeToBuildString()} ${sourceFilesToString(e)}`
            printDebug(command)
            tasks.push(execAsync(command).then(({stdout,stderr})=>{
                
            }))
        })
    }
    link = async()=>{

    }
    build = async () =>{
        
    }
}